﻿<#--------------------------------
  >>>> THIS IS RC PRODUCTION <<<<

    Setup the Session Detail

    Either Password or JWT can be used
    >> NOT BOTH <<
#>
# . C:\etc\PowerShell\var\pwdRCProd.ps1
. C:\etc\PowerShell\var\jwtRCProd.ps1

<# Do not play with these #>
    $Count    =  1000
    $endPoint = "https://platform.ringcentral.com/restapi/v2/accounts/~/phone-numbers?usageType=Inventory&perPage=$Count"
    $didArray =  @()

Function rcInventory {
    $Numbers    = Invoke-RestMethod -Method GET -Uri $endPoint -Headers $Header
    $Page       = $Numbers.paging.page
    $totalPages = $Numbers.paging.totalPages
      if ( $Page -ne $totalPages )
           { $setPage = $Page + 1
             $endPoint = "https://platform.ringcentral.com/restapi/v2/accounts/~/phone-numbers?usageType=Inventory&page=$setPage&perPage=$Count"
             (rcInventory)
           }
    return $Numbers
 }

$inventory = (rcInventory).records
foreach($Item in $inventory)
{
    $didObject = New-Object System.Object
    $didObject | Add-Member -MemberType NoteProperty -Name "phoneNumber"       -Value $Item.phoneNumber
    $didObject | Add-Member -MemberType NoteProperty -Name "phoneNumberID"     -Value $Item.id
    $didObject | Add-Member -MemberType NoteProperty -Name "Location"          -Value $Item.location
    $didObject | Add-Member -MemberType NoteProperty -Name "Type"              -Value $Item.type
    $didObject | Add-Member -MemberType NoteProperty -Name "tollType"          -Value $Item.tollType
    $didObject | Add-Member -MemberType NoteProperty -Name "usageType"         -Value $Item.usageType
    $didObject | Add-Member -MemberType NoteProperty -Name "extensionID"       -Value $Item.extension.id
    $didObject | Add-Member -MemberType NoteProperty -Name "extensionNumber"   -Value $Item.extension.extensionNumber
    $didObject | Add-Member -MemberType NoteProperty -Name "Status"            -Value $Item.status
    $didObject | Add-Member -MemberType NoteProperty -Name "Label"             -Value $Item.label
    $didObject | Add-Member -MemberType NoteProperty -Name "Primary"           -Value $Item.primary
    $didArray += $didObject
}
<#
    Set these outside of the Function above
    Options: [ csv | json | Console ]
#>
    $outputType = "json"
    $fileName   = "rcInventory." + (Get-Date -Format "ddMMMyyyy.HHmmss") + "." + "$outputType"
    $saveTo     = "C:\etc\PowerShell\A.out\$fileName"

if($outputType -eq "csv")
{
    $didArray | export-csv $saveTo -NoTypeInformation
    Write-Host "DONE outFile $SaveTo"
    Write-Host ""
}

elseif($outputType -eq "json")
{
    $inventory | ConvertTo-Json -Depth 107 -AsArray > $saveTo
    Write-Host "DONE outFile $SaveTo"
    Write-Host ""
}

else
{
    $didArray | FT -AutoSize -Property phoneNumber,phoneNumberID,Location,Type,tollType,usageType,extensionID,extensionNumber,Status,Label,Primary
    Write-Host "DONE"
    Write-Host ""
}

<#
    For testing various elements in phoneNumber Objects
    These will show on console after all of above
#>
# (rcInventory).records
# (rcInventory).paging
# (rcInventory).navigation
# (rcInventory).navigation.firstPage
# (rcInventory).navigation.nextPage
# (rcInventory).navigation.lastPage

<#
    We're outa here...
#>